
#include  <msp430x14x.h>
#include  "projekt.h"

int chars=0;             // Var. zur Speicherung der Anzahl Zeichen pro Zeile
int row=0;               // Var. zur Speicherung der aktuellen Zeile


void LCDClock(void)
{
  P5OUT&=~0x01;           // und jetzt auf low
  wait(1);
}

void LCDHome(void)
{
  row=0;                                // Zeilen- und Zeichencounter resetten
  chars=0;
  P4OUT=0x02;                           // nur return home, ohne Clear Display
  P5OUT=0x01;                           // RS und R/W low, E high
  LCDClock();                           // Befehl ausfhren
  wait(1);                              // Return home braucht was lnger
}

void LCDClear(void)
{
  row=0;                  // Zeilen- und Zeichencounter resetten
  chars=0;
  P4OUT=0x01;             // Clear Display
  P5OUT=0x01;             // RS und R/W low, E high
  LCDClock();             // Befehl ausfhren
  wait(400);              // Clear Display braucht was lnger
}

void LCDInit(void)        // LCD initialisieren
{
  P4OUT=0x38;             // 8 bit Operation, 2-Zeilen-Display, 5*8 dot font
  P5OUT=0x01;             // RS und R/W low, E high
  LCDClock();             // Befehl ausfhren
  //P4OUT=0x0F;             // Display anschalten, Cursor an, Cursor blinkt
  //P4OUT=0x0E;             // Display anschalten, Cursor an, Cursor blinkt nicht
  P4OUT=0x0C;             // Display anschalten, Cursor aus,  
  P5OUT=0x01;             // RS und R/W low, E high
  LCDClock();             // Befehl ausfhren
  P4OUT=0x06;             // cursorrichtung: nach rechts; kein Display-Shift
  P5OUT=0x01;             // RS und R/W low, E high
  LCDClock();             // Befehl ausfhren
}

void LCDOutc(unsigned char str)
{
  switch (str)                  // Sonderzeichen fr die Ausgabe auf dem Display
  {                             // umwandeln
    case '':
      str = 0xE1;
      break;
    case '':
      str = 0xEF;
      break;
    case '':
      str = 0xF5;
      break;
    case '':
      str = 0xE2;
      break;
    case '':
      str = 0xDF;
      break;
    case '':
      str = 0xE4;
      break;
  }  
  P4OUT=str;                            // str einfach an den Port schicken
  P5OUT|=0x05;                          // RS und E high
  P5OUT&=~0x02;                         // R/W low
  LCDClock();                           // Befehl ausfhren

  chars ++; // zaehlvar . eins erhoehen
  if( chars == 20)
  {
      chars =0;
      if( row ==1)
      {
          SecondLine (); // In die zweite Zeile springen
     }
      if( row ==2)
      {
        ThirdLine (); // In die dritte Zeile springen
      }
      if( row ==3)
      {
          FourthLine (); // In die vierte Zeile springen
      }
  }
}

void LCDOuts(unsigned char* str)
{
  while (*str != 0) {LCDOutc(*str++);}
}

void ThirdLine(void)
{
   P4OUT=0x94;                  // In die dritte Zeile Springen
   P5OUT=0x01;                  // RS und R/W low, E high
   LCDClock();                  // Befehl ausfhren
   row= 3; // Position speichern
   chars = 0;
}

void SpaceOut(int num)       // Gibt die bergebene Anzahl an Leerzeichen aus
{
  int ii= 0;
  while(ii < num)
  {
    LCDOutc(' ');
    ii++;
  }
}




